<template>
  <div class="home">
    <v-top></v-top>
    <div class="g-body">
      <swiper
        :indicator-dots="false"
        :autoplay="false"
        :circular="false"
        :vertical="true"
        :duration="500"
        :style="{width:'100%',height:windowHeight}"
      >
        <swiper-item :style="{width:'100%',height:windowHeight}">
          <div class="name">
            <div class="left" @click="info">
              <text class="u-label">{{memberInfo.memberName}}</text>
              <image
                mode="scaleToFill"
                style="height:16rpx;width:13rpx;margin-left:16rpx"
                :src="arrow_right"
                alt=""
              ></image>
            </div>
            <div class="right" @click="myright">
              <text class="u-label">可用积分</text>
              <text class="u-value">{{memberInfo.currentAvailablePoints}}</text>
              <image
                mode="scaleToFill"
                style="height:16rpx;width:13rpx;margin-left:16rpx"
                :src="arrow_right"
                alt=""
              ></image>
            </div>
          </div>
          <div class="section-top">
            <div class="banner" @click="event().navigateToWebView()" :style="'height:'+imageHeight+'px'">
              <image
                class="banner-img"
                :src="bannerInfo.adsPicture"
                mode="aspectFill"
                lazy-load="false"
              ></image>
            </div>
            <div class="banner-footer">
              <div class="arrow-group">
                <image
                  class="arrow-down arrow-down-1"
                  :src="arrow_right"
                  mode="scaleToFill"
                  lazy-load="false"
                ></image>
                <image
                  class="arrow-down arrow-down-2"
                  :src="arrow_right"
                  mode="scaleToFill"
                  lazy-load="false"
                ></image>
              </div>
              <text class="nav-down-text">下滑进入积分商城</text>
            </div>
          </div>
        </swiper-item>
        <swiper-item :style="{width:'100%',height:windowHeight}">
          <div class="section-goods">
            <!-- 菜单组件 -->
            <div class="section-goods-menu">
              <div class="dropdown-menu">
                <div class="dropdown-menu__item " @click="event().sort($event)">
                  <span :class="[sortType==='desc'?'dropdown-menu__title--down':'','dropdown-menu__title']">
                    <div class="ellipsis">积分</div>
                  </span>
                </div>
                <div class="dropdown-menu__item" @click="event().showTypePicker()">
                  <span :class="[isShowPicker?'dropdown-menu__title--down':'','dropdown-menu__title']">
                    <div class="ellipsis">类型</div>
                  </span>
                </div>
              </div>
              <div class="exchange-records" @click="event().toRecords()">
                <span>兑换记录</span>
              </div>
              <div :class="[isShowPicker?'dropdown-item-avtive':'','dropdown-item','dropdown-item--down']">
                  <div class="overlay" v-show="isShowPicker" @click="isShowPicker = false"></div>
                  <div class="popup popup--top dropdown-item__content">
                    <div class="cell" v-for="(item,index) in typeList" :key="index" @click="event().selectType(item.type)">
                      <div class="cell__title">
                        <span>{{item.text}}</span>
                      </div>
                    </div>
                  </div>
              </div>
            </div>
            <!-- 商品列表 -->
            <div class="goods">
              <scroll-view
                scroll-y 
                :style="{width:'100%',height:windowHeight}"
                refresher-default-style="none"
              >
                <div class="goods-list">
                  <div :class="[item.canExchange?'':'disabled','goods-item']" v-for="(item,index) in goodsList" :key="index" @click="event().toDetail(item)">
                    <div class="img-con">
                      <!-- <div class="coupon-img-title" v-if="item.exchangeType==='coupon'">GIADA</div> -->
                      <image
                        :src="item.productImg"
                        class="product"
                        mode="aspectFit"
                        lazy-load="false">
                      </image>
                    </div>
                    <div class="goods-title">
                      <div class="goods-name">{{item.productName}}</div>
                      <div class="integral">
                        积分：<span class="integral-num">{{item.exchangePoints}}</span>
                      </div>
                    </div>
                  </div>
                </div>
              </scroll-view>
            </div>
          </div>
        </swiper-item>
      </swiper>
    </div>
    <div class="float-button" @click="event().toSearch()">
      <img style="width:80%;height:80%" src="../../../../static/images/search.png" alt="">
    </div>
  </div>
</template>
<script>
import {
  VeevlinkLogin,
  VeevlinkIslogin,
  VeevlinkClient,
  VeevlinkData
} from "@/utils/base";
import {
  get,
  showToast,
  setStorageSync,
  getStorageSync,
  scanCode
} from "@/util";
import config from "@/config";
import store from "@/store";
import hintbox from "@/components/hintbox/hintbox.vue";
import top from "@/components/top/top.vue";
import name from "@/components/name/name.vue";
import {mapState} from 'vuex';
export default {
  data() {
    return {
      bannerFooterHeight: 0,
      windowHeight:0,
      isShowPicker:false,
      imageHeight:835,
      userInfo: {
        name: "",
        memberPoint:0,
      },
      sortType:'desc',
      exchangeTypeActive:'',
      bannerInfo: {},
      typeList:[
        {text:'全部',type:''},
        {text:'礼券',type:'coupon'},
        {text:'商品',type:'product'}
        ],
      goodsList:[],
      arrow_right: config.url + "right.png",
      namelist: [
        {
          text: "左远方",
          type: "name"
        },
        {
          text: "可用积分88888",
          type: "link"
        }
      ]
    };
  },
  components: {
    "v-top": top,
    "v-name": name
  },
  computed: {
    ...mapState(['memberInfo'])
  },
  methods: {
    onPulling(e) {
      console.log('onPulling:', e)
    },
    onRefresh() {
      
    },
    /*  =====自定义函数/方法区start===== */
    handler() {
      return {
        //todo:替换url
        replaceUrl: (domain, url) => {
          //删除url原有域名
          const DeleteDomainUrl = url.substring(
            url.indexOf(".com/") + 4,
            url.length
          );
          //转码
          const normalUrl = DeleteDomainUrl.replace(/&amp;/g, "&");
          return domain + normalUrl;
        }
      };
    },
    /*  =====自定义函数/方法区end===== */

    /* ======事件区start======= */
    event() {
      return {
        showTypePicker:()=>{
          console.log('111');
          this.isShowPicker = !this.isShowPicker
        },
        // todo:商品详情
        toDetail:(item)=>{
          // if(item.canExchange){
          //   config.href(`${config.shop.detail}?productId=${item.productId}&type=${item.exchangeType}`);
          // }
           config.href(`${config.shop.detail}?productId=${item.productId}&type=${item.exchangeType}`);
        },
        navigateToWebView:()=>{
          console.log("跳转web view");
          config.href(config.shop.bannerWebView);
        },
        //todo:兑换记录
        toRecords:()=>{
          config.href(`${config.shop.record}`);
        },
        //todo:搜索
        toSearch:()=>{
          console.log('搜索页面');
          config.href(`${config.shop.search}?grade=${this.memberInfo.grade}&memberPoint=${this.memberInfo.currentAvailablePoints}`)
        },
        //todo:积分排序
        sort:(event)=>{
          this.network().runApiToGetGoodsList()
        },
        // todo:选择类型
        selectType:(type)=>{
           this.isShowPicker = false
           this.exchangeTypeActive = type
           this.network().runApiToGetGoodsList()
        }
      };
    },
    /* ======事件区end======= */

    /* =======网络请求区start======= */
    network() {
      return {
        //todo:获取商城广告图以及链接
        runApiToGetBannerInfo: () => {
          let VerificationCodeEntity = wx.getStorageSync(
            "informationwx23bcedfe9e867c13"
          );
          VeevlinkClient(
            "/points/homepage?openId=" + VerificationCodeEntity.OpenId,
            "GET",
            "",
            data => {
              console.log(data);
              if (data.success) {
                this.bannerInfo = data.records[0];
                this.bannerInfo.adsPicture = this.handler().replaceUrl(
                  "http://redstone-uat-site.veevlink.com",
                  data.records[0].adsPicture
                );
              } else {
                this.hintbox.show = true;
                this.hintbox.text = success.message;
              }
            },
            error => {
              console.log(error);
            }
          );
        },
        //todo:获取商品列表
        runApiToGetGoodsList: (query) => {
          let VerificationCodeEntity = wx.getStorageSync(
            "informationwx23bcedfe9e867c13"
          );
          let data = {
            openId: VerificationCodeEntity.OpenId,
            type:'list',
            sortType: this.sortType,
            exchangeType: this.exchangeTypeActive,
            grade: this.memberInfo.grade,
            memberPoint: this.memberInfo.currentAvailablePoints,
            searchParam: ""
          };
          VeevlinkClient(
            "/points/product/list",
            "POST",
            data,
            data => {
              console.log(data);
              if (data.success) {
                data.records.forEach(item=>{
                    item.productImg = this.handler().replaceUrl("http://redstone-uat-site.veevlink.com",item.productImg)
                })
                this.goodsList = data.records;
                this.sortType==='desc'?this.sortType = 'asc':this.sortType = 'desc'
              } else {
                this.hintbox.show = true;
                this.hintbox.text = success.message;
              }
            },
            error => {
              console.log(error);
            }
          );
        }
      };
    },
    /* =======网络请求区end======= */
  },
  onReachBottom: function() {
    console.log("上拉加载更多");
  },
  onPullDownRefresh: function() {
    console.log("下拉刷新事件");
  },
  onReady(){

    
  },
  onShow() {
    wx.getSystemInfo({
      success:res=>{
        this.windowHeight = (res.windowHeight)+'px'
          console.log(res.windowHeight-70-40-56-40);
          this.imageHeight = res.windowHeight-70-40-56-40
        // if(res.windowHeight>672){
        //   this.imageHeight = (res.windowHeight-185)*2
        // }
      }
    })
    
  },
  onLoad() {
    this.network().runApiToGetBannerInfo();
    this.network().runApiToGetGoodsList();
  }
};
</script>
<style>
page{
  overflow: hidden;
}
</style>

<style lang="scss"  type="text/scss" scoped>
.float-button{
  position: fixed;
  width:90rpx;
  z-index: 1000;
  height: 90rpx;
  background-color: #EEEEEE;
  right:35rpx;
  bottom:50rpx;
  border-radius: 50%;
  display: flex;
  align-items: center;
  justify-content: center;
  box-sizing: border-box;
  padding:10rpx;
}
.home {
  margin-top: 80rpx;
  box-sizing: border-box;
  .g-body {
    // border-top: 1rpx solid #d2d2d3;
    .name {
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding: 0 59rpx;
      height: 128rpx;
      .left,
      .right {
        display: flex;
        align-items: center;
      }
      .u-label {
        font-family: STXihei;
        font-size: 30rpx;
        color: #666464;
      }
      .u-value {
        margin-left: 4rpx;
        font-family: GillSans;
        color: #727171;
        font-size: 28rpx;
      }
    }
    .section-top {
      // height: 100vh;
      .banner {
        height: 835rpx;
        .banner-img {
          width: 100%;
          height: 100%;
        }
      }
      .banner-footer {
        // height: 160rpx;
        margin-top: 20rpx;
        display: flex;
        align-items: center;
        flex-direction: column;
        justify-content: center;
        text-align: center;
        .arrow-group {
          display: flex;
          flex-direction: column;
          align-items: center;
          animation: bounce-down 1.5s linear infinite;
          .arrow-down {
            transform: rotate(90deg);
            width: 17rpx;
            height: 34rpx;
          }
          .arrow-down-2 {
            margin-top: -12rpx;
          }
        }
        .nav-down-text {
          margin-top: 20rpx;
          font-size: 26rpx;
          color: #666464;
          font-family: STXihei;
        }
        @keyframes bounce-down {
          25% {
            transform: translateY(-5px);
          }
          50%,
          100% {
            transform: translateY(0);
          }
          75% {
            transform: translateY(5px);
          }
        }
      }
    }
  }
}
.section-goods {

  border-top: 1rpx solid #d2d2d3;
  position: relative;
  .section-goods-menu {
    border-bottom: 1rpx solid #ccc;

    width: 100%;
    display: flex;
    align-items: center;
    justify-content: space-between;
    padding: 0 60rpx;
    height: 100rpx;
    box-sizing: border-box;
    
    .dropdown-menu {
      
      display: flex;
      background-color: #fff;
      user-select: none;
      .dropdown-menu__item {
        display: flex;
        align-items: center;
        justify-content: center;
        outline: none;
        cursor: pointer;
        .dropdown-menu__title {
          margin-right: 120rpx;
          position: relative;
          box-sizing: border-box;
          max-width: 100%;
          padding: 0 16rpx;
          color: #323233;
          font-size: 26rpx;
          line-height: 18px;
          .ellipsis {
            overflow: hidden;
            white-space: nowrap;
            text-overflow: ellipsis;
          }
        }
        .dropdown-menu__title::after {
          position: absolute;
          top: 50%;
          right: -4px;
          margin-top: -5px;
          border: 3px solid;
          border-color: transparent transparent currentColor currentColor;
          transform: rotate(-45deg);
          opacity: 0.8;
          content: "";
        }
        .dropdown-menu__title--down::after {
            margin-top: -1px;
            -webkit-transform: rotate(135deg);
            transform: rotate(135deg);
        }
      }
    }
    .dropdown-item {
      box-sizing: border-box;
        // border-bottom: 1rpx solid #666464;
        box-shadow:0 8rpx 4rpx rgba(0, 0, 0, 0.1), 0 0 20rpx rgba(0, 0, 0, 0.1) inset;
        position: absolute;
        z-index: 2030;
        top: 101rpx;
        left:0;
        width: 100%;
        // transform: translateY(-150%);
        border-top: 1rpx solid #ccc;
        height: 0;
        overflow: hidden;
        transition: height 0.2s;
      }
      .dropdown-item-avtive{
        height:260rpx;
      }
      .popup{
        transition: transform 0.3s ease-out, -webkit-transform 0.3s ease-out;
      }
      .overlay {
        animation-duration: 0.2s;
        position: fixed;
        top: 100rpx;
        left: 0;
        z-index: -1;
        width: 100%;
        height: 100%;
        background-color: transparent;
      }
      .cell {
        position: relative;
        display: -webkit-box;
        display: -webkit-flex;
        display: flex;
        box-sizing: border-box;
        width: 100%;
        padding: 10px 16px;
        overflow: hidden;
        color: #323233;
        font-size: 14px;
        line-height: 24px;
        background-color: #fff;
      }
      .cell:not(:last-child)::after {
        position: absolute;
        box-sizing: border-box;
        content: ' ';
        pointer-events: none;
        right: 0;
        bottom: 0;
        left: 16px;
        border-bottom: 1px solid #ebedf0;
        transform: scaleY(0.5);
    }
    .exchange-records {
      box-sizing: border-box;
      padding-bottom: 8rpx;
      border-bottom: 1rpx solid #666464;
    }
  }
  .goods{
    .goods-list{
        padding-bottom: 182rpx;
      display: flex;
      flex-wrap:wrap;
      .disabled{
        opacity: .3;
      }
      .goods-item{
        display: flex;
        align-items: center;
        flex-direction: column;
        text-align: center;
        width: 50%;
        height:594rpx ;
        background: #EEEEEE;
        border-bottom: 2rpx solid #fff;
        box-sizing: border-box;
        .img-con{
          margin-top: 74rpx;
          display: flex;
          align-items: center;
          flex-direction: column;
          width:226rpx;
          height:324rpx;
          .coupon-img-title{
            margin-bottom: 80rpx;
            font-size: 22rpx;
            font-family:GillSans;
          }
        }
        .product{
          width: 100%;
          height: 100%;
        }
        .coupon{
          width:100%;
          height: 98rpx;
        }
        
        .goods-name,.integral{
          color:#333;
          font-family:GillSans-Light,GillSans;
        }
        .goods-name{
          margin-top: 65rpx;
          font-size: 22rpx;
        }
        .integral{
          margin-top: 18rpx;
          font-size: 18rpx;
          font-family:STXihei;
          .integral-num{
            font-size:22rpx;
            font-family:GillSans;
          }
        }
      }
      .goods-item:nth-child(odd){
        border-right: 2rpx solid #fff;
      }
    }
  }
}
</style>
